# -*- coding: utf-8 -*-
"""
Created on Thu Feb 15 18:04:56 2024

@author: aleja
"""
import numpy as np
import pandas as pd
import matplotlib.pyplot as plt

datos=[]
#1 abrir archivo.csv
 

datos = pd.read_csv('d00_te.csv')
shape = datos.shape
n=len(datos.axes[0])
m=len(datos.axes[1])


#2 normalizar a media conocida y varianza 1
    
valor_medio = datos.mean(axis=0)
variable_centralizada = datos - valor_medio

desviacion_estandar = datos.std(axis=0)

X = variable_centralizada / desviacion_estandar
Xn=X.to_numpy()


#3 cakcualar la covarianza de x

r=1/(n-1)*np.dot(np.transpose(Xn), Xn)    #52x52 es el tamaño que buscamos
#r=np.cov                                   #960x960



#4 calcular los valores propios, valores singulares de la matriz

v,s, vt=np.linalg.svd(r) #u mat vect sing izq, s valores singulares R ordenados enforma descend, v vec sing derec

#5 componentes principales

t=np.dot(Xn,v)

#print(np.shape(t)) 


variabilidad=90
variabilidadc=0
a=0

traza=sum(s)

while (variabilidadc < variabilidad and a <len(s)):
    variabilidadc = variabilidadc+(s[a]/traza)*100
    a=a+1
 #   print (a)
  #  print (variabilidadc)

#print('hace ',a,'iteraciones') 

p=v[:,:a]              #matriz de tamaño xa
sa=np.diag(s[:a])

ta=np.dot(Xn, p)
#print(np.shape(ta))    #960xa

#detectar fallos

#xn = [fila.reshape(1, -1) for fila in Xn]
#print(mat_desc)
#print(np.shape(xn))
#print(np.shape(p))

#print (np.shape(xn[0]))

T2=[]
for i in range (n):
    
    multi=np.dot(np.dot(np.dot(np.dot(Xn[i,:], p), np.linalg.inv(sa)), np.transpose(p)), np.transpose(Xn[i,:]))

    T2=np.append(T2,multi)
#print(T2)

Tumbral=np.percentile(T2,99)
#print(Tumbral)


#calcular la estadistica Q
Q=[]

for i in range(960):
    R=Xn[i,:]-np.dot(np.dot(Xn[i,:],p),np.transpose(p))
    Rt=np.transpose(R) #para que de la forma adecuada
    Qi=np.dot(Rt,R)
    Q=np.append(Q,Qi)
    
#print(np.shape(Q))
#print(Q)

Qumbral=np.percentile(Q,99)

#hacer graficas

ejex=np.arange(n)

plt.title('PCA T2')
plt.xlabel('t')
plt.ylabel('T^2')
plt.scatter(ejex, T2, c ="green")
plt.axhline(y=Tumbral, color="r", label="Percentil 99")
plt.show()


plt.title('PCA Q')
plt.xlabel('t')
plt.ylabel('Q')
plt.scatter(ejex, Q, c ="blue")
plt.axhline(y=Qumbral, color="r", label="Percentil 99")
plt.show()  


###guardar datos en un fichero

np.savez("fich_datos_PCA",p=p,sa=sa,Qumbral=Qumbral,Tumbral=Tumbral,valor_medio=valor_medio,desviacion_estandar=desviacion_estandar)

print(Tumbral);
print(Qumbral);
